## Name

systemd-cgtop — Show top control groups by their resource usage

## Synopsis

`systemd-cgtop [OPTIONS...]`

## Description

systemd-cgtop shows the top control groups of the local Linux control group hierarchy, ordered by their CPU, memory and disk I/O load. The display is refreshed in regular intervals (by default every 1s), similar in style to top(1).

Resource usage is only accounted for control groups in the relevant hierarchy, i.e. CPU usage is only accounted for control groups in the `cpuacct` hierarchy, memory usage only for those in `memory` and disk I/O usage for those in `blkio`. systemd(1) by default places all services in their own control group in the `cpuacct` hierarchy, but not in `memory` nor `blkio`. If resource monitoring for these resources is required it is recommended to add `blkio` and `memory` to the `DefaultControllers=` setting in `/etc/systemd/system.conf` (see systemd.conf(5) for details). Alternatively, it is possible to enable resource accounting individually for services, by making use of the `ControlGroup=` option in the unit files (See systemd.exec(5) for details).

To emphasize this: unless `blkio` and `memory` are enabled for the services in question with either of the options suggested above no resource accounting will be available for system services and the data shown by systemd-cgtop will be incomplete.

## Options

The following options are understood:

`-h`, `--help`

  Prints a short help text and exits.

`-p`

  Order by control group path name.

`-t`

  Order by number of tasks in control group (i.e. threads and processes).

`-c`

  Order by CPU load.

`-m`

  Order by memory usage.

`-i`

  Order by disk I/O load.

`-d`, `--delay=`

  Specify refresh delay in seconds (or if one of `ms`, `us`, `min` is specified as unit in this time unit).

`--depth=`

  Maximum control group tree traversal depth. Specifies how deep systemd-cgtop shall traverse the control group hierarchies. If 0 is specified only the root group is monitored, for 1 only the first level of control groups is monitored, and so on. Defaults to 3.

## Keys

systemd-cgtop is an interactive tool and may be controlled via user input using the following keys:

h

  Shows a short help text.

SPACE

  Immediately refresh output.

q

  Terminate the program.

p, t, c, m, i

  Change ordering of control groups by path, number of tasks, CPU load, memory usage resp. IO load.

+, -

  Increase, resp. decrease refresh delay.

## Exit status

On success 0 is returned, a non-zero failure code otherwise.

## See Also

systemd(1), systemctl(1), systemd-cgls(1), top(1)